/***********************************************
*  Access.ini for players	(example: "nick or ip" "pass" "flags")
*  Denied.ini for subnets	(example: "ip" "mask" "flags")
*
*  if #define SUBNET_REVERSE is comment then
*  Access.ini list of nicks,who can join from banned subnets
*  Denied.ini list of banned subnets
*
*  if #define SUBNET_REVERSE is uncomment then
*  Access.ini list of nicks,who can't join from access subnets
*  Denied.ini list of access subnets,others are banned
*
*  ATTENTION!!! HELP for BAN (for that who don't know)
*  http://ipcalc.dewil.ru/
*
************************************************
*
*  CREATE TABLE bansubnets (
*  id int(11) NOT NULL auto_increment,
*  subipaddr VARCHAR(32) NOT NULL,
*  bitmask VARCHAR(2) NOT NULL,
*  flags VARCHAR(32) NOT NULL,
*  comment TEXT NOT NULL,
*  PRIMARY KEY (id));
*
*  CREATE TABLE subplayers (
*  id int(11) NOT NULL auto_increment,
*  ident VARCHAR(32) NOT NULL,
*  password VARCHAR( 32) NOT NULL,
*  flags VARCHAR(32) NOT NULL,
*  comment TEXT NOT NULL,
*  PRIMARY KEY (id));
*
***********************************************/

// uncomment if subnet only
//#define SUBNET_REVERSE

#include <amxmodx>
#include <amxmisc>
#include <sqlx>

// Variables
new Handle:query
new Handle:info
new Handle:sql
new bs_host[32], bs_user[32], bs_pass[32], bs_db[16], table[16], error[128], errno
new DeniedFile[64], AccessFile[64]
new Ident[32], Apass[32], UFlags[22]
new Subipaddr[16], Bitmask[16], Subipmask[16]
#if defined SUBNET_REVERSE
new SFlags[22]
#endif
new bool:PlayerFound[32] = false
new bool:SubnetFound[32] = false
new bool:PassNick[32] = false
new name[32], ip[16], pass[16]

// Options
new Password[] = "_pw"							// default value of amx or amxx access password
new BanSubMSG[] = "%s Your subnet was limited on server. Info %s"	// Show this message when players from banned subnets was kicked
new WrongPassMSG[] = "%s Wrong Password on Nick"				// Show this message if password on nick not right
new WEBRESOURCE[] = "http://217.10.43.239/BanSubnets.php"		// Site of Server for communicate with admins

// Strings Messages
new Tag[] = "[BanSubnets]"						// Plugin Tag
new EmptyPlMSG[] = "%s Player not found"
new EmptySNMSG[] = "%s Subnet not found"
new NotConnectMSG[] = "%s SQL error: can't connect: '%s'"
new NotLoadPlMSG[] = "%s SQL error: can't load players: '%s'"
new NotLoadSNMSG[] = "%s SQL error: can't load subnets: '%s'"

public plugin_init() {
	register_plugin("BanSubnets(+MySQL)","3.7","Z@C,NO PASARAN,RUNET")
	register_cvar("bs_sql_host", "")
	register_cvar("bs_sql_user", "")
	register_cvar("bs_sql_pass", "")
	register_cvar("bs_sql_db", "")
	register_cvar("bs_sql_subplayers", "")
	register_cvar("bs_sql_bansubnets", "")

	new confdir[64]
	get_configsdir(confdir, 63)
	format(AccessFile, 63, "%s/BanSubnets/Access.ini", confdir)
	format(DeniedFile, 63, "%s/BanSubnets/Denied.ini", confdir)
	server_cmd("exec %s/BanSubnets/BS_SQL.cfg", confdir)
	server_exec()

	get_cvar_string("bs_sql_host", bs_host, 31)
	get_cvar_string("bs_sql_user", bs_user, 31)
	get_cvar_string("bs_sql_pass", bs_pass, 31)
	get_cvar_string("bs_sql_db", bs_db, 15)

	set_task(0.1,"CreateSQLTable")
}

public CreateSQLTable() {
	info = SQL_MakeDbTuple(bs_host, bs_user, bs_pass, "")
	sql = SQL_Connect(info, errno, error, 127)

	if (sql == Empty_Handle) {
		server_print(NotConnectMSG, Tag, error)
		return PLUGIN_HANDLED
	} else {
		SQL_QueryAndIgnore(sql, "CREATE DATABASE IF NOT EXISTS %s", bs_db)

		get_cvar_string("bs_sql_subplayers", table, 15)
		SQL_QueryAndIgnore(sql, "CREATE TABLE IF NOT EXISTS %s.%s (id INT(11) NOT NULL AUTO_INCREMENT, ident VARCHAR(32) NOT NULL, password VARCHAR(32) NOT NULL, flags VARCHAR(32) NOT NULL, comment TEXT, PRIMARY KEY (id)) COMMENT='Subnet Players'", bs_db, table)
	
		get_cvar_string("bs_sql_bansubnets", table, 15)
		SQL_QueryAndIgnore(sql, "CREATE TABLE IF NOT EXISTS %s.%s (id INT(11) NOT NULL AUTO_INCREMENT, subipaddr VARCHAR(32) NOT NULL, bitmask VARCHAR(15) NOT NULL, flags VARCHAR(32) NOT NULL , comment TEXT, PRIMARY KEY (id)) COMMENT='Subnets'", bs_db, table)
	}
	SQL_FreeHandle(sql)
	SQL_FreeHandle(info)
	return PLUGIN_CONTINUE
}

public client_connect(id) {
	if (is_user_bot(id) || access(id, ADMIN_RESERVATION) || is_user_hltv(id)) {
		return PLUGIN_HANDLED
	} else {
		get_user_name(id, name, 31)
		get_user_ip(id, ip, 15, 1)
		get_user_info(id, Password, pass, 15)
		PlayerFound[id] = false, PassNick[id] = false

		info = SQL_MakeDbTuple(bs_host, bs_user, bs_pass, bs_db)
		sql = SQL_Connect(info, errno, error, 127)

		if (sql == Empty_Handle) {
			server_print(NotConnectMSG, Tag, error)
			if (file_exists(AccessFile)) {
				new Areaddata[101], Alen, Apos = 0
				if (!file_size(AccessFile, 0)) {
					Denied(id)
					server_print(EmptyPlMSG, Tag)
				} else {
					while(read_file(AccessFile, Apos++, Areaddata, 100, Alen)) {
						if (Areaddata[0] == ';' || !Alen)
							continue

						parse(Areaddata, Ident, 31, Apass, 31, UFlags, 21)
						if (equal(Ident, name) || equal(Ident, ip)) {
							plrAccess(id)
						}
					}
				}
			}
		} else {
			if (contain(name, "'") > -1) {
				replace_all(name, 31, "'", "''")
			}
			get_cvar_string("bs_sql_subplayers", table, 15)
			query = SQL_PrepareQuery(sql, "SELECT password, flags FROM %s WHERE ident='%s' or ident='%s'", table, name, ip)
			if (!SQL_Execute(query)) {
				SQL_QueryError(query, error, 127)
				server_print(NotLoadPlMSG, Tag, error)
			} else {
				if (!SQL_NumResults(query)) {
					server_print(EmptyPlMSG, Tag)
				} else {
					new colPass = SQL_FieldNameToNum(query, "password")
					new colUFlags = SQL_FieldNameToNum(query, "flags")
					SQL_ReadResult(query, colPass, Apass, 31)
					SQL_ReadResult(query, colUFlags, UFlags, 31)
					plrAccess(id)
				}
			}
			SQL_FreeHandle(query)
			SQL_FreeHandle(sql)
		}
		SQL_FreeHandle(info)
	}
	check_plr(id)
	return PLUGIN_HANDLED
}

public Denied(id) {
	info = SQL_MakeDbTuple(bs_host, bs_user, bs_pass, bs_db)
	sql = SQL_Connect(info, errno, error, 127)

	if (sql == Empty_Handle) {
		server_print(NotConnectMSG, Tag, error)
		if (file_exists(DeniedFile)) {
			new Dreaddata[50], Dlen, Dpos = 0
			if (!file_size(DeniedFile, 0)) {
				server_print(EmptySNMSG, Tag)
			} else {
				while(read_file(DeniedFile, Dpos++, Dreaddata, 50, Dlen)) {
					if (Dreaddata[0] == ';' || !Dlen)
						continue

					#if defined SUBNET_REVERSE
					parse(Dreaddata, Subipaddr, 16, Bitmask,  16, SFlags ,21)
					#else
					parse(Dreaddata, Subipaddr, 16, Bitmask, 16)
					#endif
					check_sub(id)
				}
			}
		}
	} else {
		get_cvar_string("bs_sql_bansubnets", table, 15)
		#if defined SUBNET_REVERSE
		query = SQL_PrepareQuery(sql, "SELECT subipaddr, bitmask, flags FROM %s", table)
		#else
		query = SQL_PrepareQuery(sql, "SELECT subipaddr, bitmask FROM %s", table)
		#endif
		if (!SQL_Execute(query)) {
			SQL_QueryError(query, error, 127)
			server_print(NotLoadSNMSG, Tag, error)
		} else {
			if (!SQL_NumResults(query)) {
				server_print(EmptySNMSG, Tag)
			} else {
				new colSubipaddr = SQL_FieldNameToNum(query, "subipaddr")
				new colBitmask = SQL_FieldNameToNum(query, "bitmask")
				#if defined SUBNET_REVERSE
				new colSFlags = SQL_FieldNameToNum(query, "flags")
				#endif
				while (SQL_MoreResults(query)) {
					SQL_ReadResult(query, colSubipaddr, Subipaddr, 16)
					SQL_ReadResult(query, colBitmask, Bitmask, 16)
					#if defined SUBNET_REVERSE
					SQL_ReadResult(query, colSFlags, SFlags, 31)
					#endif
					check_sub(id)
					SQL_NextRow(query)
				}
			}
		}
		SQL_FreeHandle(query)
		SQL_FreeHandle(sql)
	}
	SQL_FreeHandle(info)
	return PLUGIN_HANDLED
}

plrAccess(id) {
	if (equal(Apass, pass) || strlen(Apass) == 0) {
		PlayerFound[id] = true
		if (strlen(UFlags) > 0) {
			remove_user_flags(id)
			set_user_flags(id, read_flags(UFlags))
		}
	} else {
		if (!equal(Apass, pass)) {
			PassNick[id] = true
			action(id)
		}
	}
}

check_plr(id) {
	if (PlayerFound[id]) {
		console_print(0, "FOUND")
		return PLUGIN_HANDLED
	} else {
		Denied(id)
	}
	return PLUGIN_HANDLED
}

check_sub(id) {
	SubnetFound[id] = false
	if (strlen(Bitmask) > 2) {
		Subipmask = Bitmask
	}
	if (strlen(Bitmask) < 3) {
		bitmask_to_mask(Bitmask)
	}
	if (net_belongs(ip_to_number(ip), ip_to_number("255.255.255.255"), ip_to_number(Subipaddr), ip_to_number(Subipmask)) == 1) {
		SubnetFound[id] = true
		action(id)
	}else{
		actionn(id)
	}
	#if defined SUBNET_REVERSE
	if (strlen(SFlags) > 0) {
		remove_user_flags(id)
		set_user_flags(id, read_flags(SFlags))
	}
	#endif
}

bitmask_to_mask(Bitmask[]) {
	if (equal(Bitmask, "1")) format(Subipmask, 15, "128.0.0.0")
	if (equal(Bitmask, "2")) format(Subipmask, 15, "192.0.0.0")
	if (equal(Bitmask, "3")) format(Subipmask, 15, "224.0.0.0")
	if (equal(Bitmask, "4")) format(Subipmask, 15, "240.0.0.0")
	if (equal(Bitmask, "5")) format(Subipmask, 15, "248.0.0.0")
	if (equal(Bitmask, "6")) format(Subipmask, 15, "252.0.0.0")
	if (equal(Bitmask, "7")) format(Subipmask, 15, "254.0.0.0")
	if (equal(Bitmask, "8")) format(Subipmask, 15, "255.0.0.0")

	if (equal(Bitmask, "9")) format(Subipmask, 15, "255.128.0.0")
	if (equal(Bitmask, "10")) format(Subipmask, 15, "255.192.0.0")
	if (equal(Bitmask, "11")) format(Subipmask, 15, "255.224.0.0")
	if (equal(Bitmask, "12")) format(Subipmask, 15, "255.240.0.0")
	if (equal(Bitmask, "13")) format(Subipmask, 15, "255.248.0.0")
	if (equal(Bitmask, "14")) format(Subipmask, 15, "255.252.0.0")
	if (equal(Bitmask, "15")) format(Subipmask, 15, "255.254.0.0")
	if (equal(Bitmask, "16")) format(Subipmask, 15, "255.255.0.0")

	if (equal(Bitmask, "17")) format(Subipmask, 15, "255.255.128.0")
	if (equal(Bitmask, "18")) format(Subipmask, 15, "255.255.192.0")
	if (equal(Bitmask, "19")) format(Subipmask, 15, "255.255.224.0")
	if (equal(Bitmask, "20")) format(Subipmask, 15, "255.255.240.0")
	if (equal(Bitmask, "21")) format(Subipmask, 15, "255.255.248.0")
	if (equal(Bitmask, "22")) format(Subipmask, 15, "255.255.252.0")
	if (equal(Bitmask, "23")) format(Subipmask, 15, "255.255.254.0")
	if (equal(Bitmask, "24")) format(Subipmask, 15, "255.255.255.0")

	if (equal(Bitmask, "25")) format(Subipmask, 15, "255.255.255.128")
	if (equal(Bitmask, "26")) format(Subipmask, 15, "255.255.255.192")
	if (equal(Bitmask, "27")) format(Subipmask, 15, "255.255.255.224")
	if (equal(Bitmask, "28")) format(Subipmask, 15, "255.255.255.240")
	if (equal(Bitmask, "29")) format(Subipmask, 15, "255.255.255.248")
	if (equal(Bitmask, "30")) format(Subipmask, 15, "255.255.255.252")
	if (equal(Bitmask, "31")) format(Subipmask, 15, "255.255.255.254")
}

action(id) {
	/* new Reason[255]
	#if defined SUBNET_REVERSE
	if (SubnetFound[id] == false && PlayerFound[id] == false)
	#else
	if (SubnetFound[id] == true && PlayerFound[id] == false)
	#endif
	{
		format(Reason, 254, BanSubMSG, Tag, WEBRESOURCE)
		kick(id, Reason)
	}
	if (PassNick[id] == true) {
		format(Reason, 254, WrongPassMSG, Tag)
		kick(id, Reason)
	} */
	server_print("authid VALVE 1")
}
actionn(id){
	new authid[32]
	get_user_authid(id,authid,31) 
	
	if(!containi(authid,"VALVE_0:")) {
	server_print("authid VALVE 2")
	set_task(10.0,"func_show_motd",id)
	}
	
}

public func_show_motd(id) {
	show_motd(id,"You have no-steam version Counter-Strike","PlayerKicker")
	set_task(5.0,"func_disconnect",id)
}

public func_disconnect(id) {
	client_cmd(id,"disconnect")
	return PLUGIN_HANDLED
}


kick(id, Reason[]) {
	server_cmd("kick #%d %s", get_user_userid(id), Reason)
}

stock ip_to_number(userip[16]) {
	new ipb1[12], ipb2[12], ipb3[12], ipb4[12], ip, nipb1, nipb2, nipb3, nipb4, uip[16]
	copy(uip, 16, userip)
	while(replace(uip, 16, ".", " ")) {}
	parse(uip, ipb1, 12, ipb2, 12, ipb3, 12, ipb4, 12)
	nipb1 = str_to_num(ipb1)
	nipb2 = str_to_num(ipb2)
	nipb3 = str_to_num(ipb3)
	nipb4 = str_to_num(ipb4)
	ip = ((((nipb1 * 256) + nipb2) * 256) + nipb3) + ((((((nipb1 * 256) + nipb2) * 256) + nipb3) * 255) + nipb4) 
	return ip
}

stock net_hi_num(addr, mask) {
	return addr+4294967296-mask
}

stock net_belongs(ipaddr, ipmask, ipaddrin, ipmaskin) {
	if (ipaddr >= ipaddrin && net_hi_num(ipaddr, ipmask) <= net_hi_num(ipaddrin, ipmaskin)) {
		return 1
	}
	return 0
}
